## gemrb 0.8.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
	cmake_policy(SET CMP0005 NEW)
endif(COMMAND cmake_policy)

# prevent in-source builds
IF(NOT INSOURCEBUILD AND (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR}))
	MESSAGE(FATAL_ERROR "
		CMake generation for this project is not allowed within the source directory!
		Remove the CMake cache files and try again from another folder, e.g.:
		  rm -r CMakeCache.txt CMakeFiles/
		  mkdir build
		  cd build
		  cmake ..
		If you really want an in-source build, pass -DINSOURCEBUILD=1"
	)
ENDIF()

# If the user specifies -DCMAKE_BUILD_TYPE on the command line, take their definition
# and dump it in the cache along with proper documentation, otherwise set CMAKE_BUILD_TYPE
# to Release prior to calling PROJECT()
IF(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ELSE(DEFINED CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF(DEFINED CMAKE_BUILD_TYPE)

PROJECT(gemrb)
# try to extract the version from the source
FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/gemrb/includes/globals.h GLOBALS)
SET(GEMRB_VERSION "")
STRING(REGEX MATCH "define VERSION_GEMRB .([^\"]*)" GEMRB_VERSION "${GLOBALS}")
STRING(REGEX REPLACE "define VERSION_GEMRB .([^\"]*)$" "\\1" GEMRB_VERSION "${GEMRB_VERSION}")
if(GEMRB_VERSION STREQUAL "") # lookup failed
	set(GEMRB_VERSION "unknown")
endif()
message("Detected version: ${GEMRB_VERSION}")
unset(GLOBALS)

IF(PREFIX)
	SET(CMAKE_INSTALL_PREFIX ${PREFIX})
	# cmake 3 makes internal use of this variable ...
	UNSET(PREFIX)
	UNSET(PREFIX CACHE)
ENDIF(PREFIX)

if (NOT LAYOUT)
	if (WIN32)
		set(LAYOUT "home")
	elseif (APPLE)
		set(LAYOUT "bundle")
		# favor mac frameworks over unix libraries
		set(CMAKE_FIND_FRAMEWORK FIRST)
	else (APPLE)
		set(LAYOUT "fhs")
	endif (WIN32)
endif (NOT LAYOUT)

SET(LAYOUT "${LAYOUT}" CACHE STRING "Directory layout.")

# macro that sets a default (path) if one wasn't specified
MACRO(SET_PATH variable default)
	IF(NOT ${variable})
		SET(${variable} ${default})
	ENDIF(NOT ${variable})
ENDMACRO(SET_PATH)

if (${LAYOUT} MATCHES "home")
	SET_PATH( PLUGIN_DIR ${CMAKE_INSTALL_PREFIX}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX} )
	SET_PATH( EXAMPLE_CONF_DIR ${CMAKE_INSTALL_PREFIX} )
elseif (${LAYOUT} MATCHES "fhs")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib/gemrb )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/gemrb )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/share/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	IF( NOT SYSCONF_DIR )
		if ( ${CMAKE_INSTALL_PREFIX} STREQUAL "/usr" )
			SET( SYSCONF_DIR /etc/gemrb )
		else ()
			SET( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc/gemrb )
		endif ()
	ENDIF( NOT SYSCONF_DIR )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
elseif (${LAYOUT} MATCHES "opt")
	SET_PATH( LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib )
	SET_PATH( PLUGIN_DIR ${LIB_DIR}/plugins )
	SET_PATH( DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/ )
	SET_PATH( MAN_DIR ${CMAKE_INSTALL_PREFIX}/man/man6 )
	SET_PATH( BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin )
	SET_PATH( SYSCONF_DIR ${CMAKE_INSTALL_PREFIX}/etc )
	SET_PATH( DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/gemrb )
	SET_PATH( ICON_DIR ${CMAKE_INSTALL_PREFIX}/share/pixmaps )
	SET_PATH( SVG_DIR ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps )
	SET_PATH( MENU_DIR ${CMAKE_INSTALL_PREFIX}/share/applications )
	SET_PATH( EXAMPLE_CONF_DIR ${SYSCONF_DIR} )
else (${LAYOUT} MATCHES "bundle") # Mac or iOS
	SET(CMAKE_INSTALL_RPATH @loader_path/../Frameworks)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE) 
	# most paths are irrelevant since the items will be bundled with application
	SET_PATH( BIN_DIR /Applications )
	# TODO: these should be copied during build and not install.
	SET_PATH( PLUGIN_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Plugins" )
	SET_PATH( DOC_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources" )
	SET_PATH( LIB_DIR @loader_path/../Frameworks )
endif (${LAYOUT} MATCHES "home")

# check if this is a release version
SET(RC "")
STRING(REGEX MATCH "-git$" RC ${GEMRB_VERSION})
if(RC STREQUAL "")
	set (GIT_VERSION 0)
else()
	set (GIT_VERSION 1)
endif()
MESSAGE("Git version bool: ${GIT_VERSION}")

IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wno-error=inline -Wno-error=cast-align -Wmissing-declarations")
		if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
			# clang ignores -Wno-error
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align -Winline")
		endif ()
	endif ()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -Wpointer-arith ")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-format-y2k -Wno-long-long -fno-strict-aliasing")
	# mark chars explicitly signed (ARM defaults to unsigned)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")
	# only export symbols explicitly marked to be exported.
	INCLUDE(CheckCXXCompilerFlag)
	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" VISIBILITY_HIDDEN)
	IF (VISIBILITY_HIDDEN AND NOT WIN32)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
	ENDIF ()
	CHECK_CXX_COMPILER_FLAG("-fno-stack-protector" STACK_PROTECTOR)
	IF (STACK_PROTECTOR)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-stack-protector")
	ENDIF ()
	if (WIN32)
		# GCC 4.5.0+ has shared libstdc++ without dllimport
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--enable-auto-import")
	endif (WIN32)
	# Ensure all plugin symbols exist.
	if (NOT APPLE AND NOT UNSAFE_PLUGIN)
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
	endif (NOT APPLE AND NOT UNSAFE_PLUGIN)
	# GNU systems need to define the Mersenne exponent for the RNG to compile w/o warning
	ADD_DEFINITIONS("-DSFMT_MEXP=19937")
ENDIF()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")

# Check for all the required and optional dependencies
FIND_PACKAGE(PythonLibs 2.3 REQUIRED)
IF(PYTHONLIBS_FOUND)
	MESSAGE(STATUS "Looking for Python libraries and headers: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Python libraries and headers: not found!")
	MESSAGE(FATAL_ERROR "Please get them (www.python.org)")
ENDIF()

INCLUDE(FindSDL)
IF(SDL_FOUND)
	MESSAGE(STATUS "Looking for SDL1: found")
ELSE()
	MESSAGE(WARNING "Looking for SDL1: not found!")
ENDIF()

# look for sdl2 if sdl1 was not found or a preference was stated
IF(USE_SDL2 OR NOT SDL_FOUND)
	INCLUDE(FindSDL2)
ENDIF()
IF(SDL2_FOUND)
	MESSAGE(STATUS "Looking for SDL2: found")
	# unify SDL variables, so we don't have to differentiate later
	SET(SDL_INCLUDE_DIR ${SDL2_INCLUDE_DIR})
	SET(SDL_LIBRARY ${SDL2_LIBRARY})
	# skip SDL_FOUND for later use
ELSE()
	MESSAGE(WARNING "Looking for SDL2: not found!")
	IF(NOT SDL_FOUND)
		MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
	ENDIF()
ENDIF()

IF(USE_OPENGL)
	IF(NOT SDL2_FOUND)
		MESSAGE(FATAL_ERROR "SDL2 is required for the OpenGL driver!")
	ENDIF()
	INCLUDE(FindOpenGL)
	IF(NOT OPENGL_FOUND)
		MESSAGE(FATAL_ERROR "OpenGL library not found!")
	ENDIF()

	IF(USE_OPENGL EQUAL 1)
		ADD_DEFINITIONS("-DUSE_GL")
		INCLUDE(FindGLEW)
		IF(GLEW_FOUND)
			MESSAGE(STATUS "Looking for Glew: found")
		ELSE()
			MESSAGE(SEND_ERROR "Looking for Glew: not found!")
			MESSAGE(FATAL_ERROR "Please install the Glew library and headers first!")
		ENDIF()
	ELSE()
		# use GLES instead of regular GL
		# TODO: check for all the stuff GLES needs
	ENDIF()
ENDIF()

INCLUDE(FindZLIB)
IF(ZLIB_FOUND)
	MESSAGE(STATUS "Looking for Zlib: found")
ELSE()
	MESSAGE(SEND_ERROR "Looking for Zlib: not found!")
	MESSAGE(FATAL_ERROR "Please install the Zlib library and headers first!")
ENDIF()

IF(UNIX)
	SET(CMAKE_THREAD_PREFER_PTHREAD true)
	FIND_PACKAGE(Threads REQUIRED)
ENDIF(UNIX)

INCLUDE(FindOpenAL)
IF(OPENAL_FOUND)
	MESSAGE(STATUS "Looking for OpenAL: found")
ELSE()
	MESSAGE(WARNING "Looking for OpenAL: not found!")
	MESSAGE(WARNING "If you want to build the OpenAL plugin, get OpenAL from www.openal.org.")
	MESSAGE(WARNING "If it just wasn't found, try setting the OPENALDIR environment variable.")
ENDIF()

IF(SDL2_FOUND)
	FIND_PACKAGE(SDL2_mixer MODULE)
	# unify variables, so we don't have to differentiate later
	SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
	SET(SDL_MIXER_LIBRARIES ${SDL2_MIXER_LIBRARIES})
	SET(SDL_MIXER_VERSION_STRING ${SDL2_MIXER_VERSION_STRING})
	SET(SDL_MIXER_FOUND ${SDL2_MIXER_FOUND})
ELSE()
	FIND_PACKAGE(SDL_mixer MODULE)
ENDIF()
IF(SDL_MIXER_FOUND)
	MESSAGE(STATUS "Looking for SDL_mixer: found")
ELSE()
	MESSAGE(WARNING "Looking for SDL_mixer: not found!")
	MESSAGE(WARNING "If you want to build the SDL_mixer plugin, install SDL_mixer first.")
	MESSAGE(WARNING "Make sure you use a version compatible with the chosen SDL version.")
ENDIF()

FIND_PACKAGE(LIBVLC MODULE)
IF(LIBVLC_FOUND)
	MESSAGE(STATUS "Looking for VLC: found")
ELSE()
	MESSAGE(WARNING "Looking for VLC: not found!")
	MESSAGE(WARNING "If you want to build the VLC plugin, install VLC first.")
ENDIF()

INCLUDE(FindFreetype)
IF(FREETYPE_FOUND)
	MESSAGE(STATUS "Looking for Freetype: found")
	INCLUDE(FindICONV)
	IF(NOT ICONV_FOUND)
		MESSAGE(WARNING "Iconv not found. TTF plugin will not be able to translate non-unicode compatible TLK encodings.")
	ELSE()
		set(HAVE_ICONV)
	ENDIF()
ELSE()
	MESSAGE(WARNING "Looking for Freetype: not found!")
	MESSAGE(WARNING "If you want to build the TTF plugin, install Freetype first.")
ENDIF()

INCLUDE(FindPNG)
IF(PNG_FOUND)
	MESSAGE(STATUS "Looking for libPNG: found")
ELSE()
	MESSAGE(WARNING "Looking for libPNG: not found!")
	MESSAGE(WARNING "GemRB will be built without any PNG support. Get it from www.libpng.org" )
	MESSAGE(WARNING "While no original game data is in PNG format, some mod data is and will need conversion.")
ENDIF()

FIND_LIBRARY(VORBIS_LIBRARY vorbisfile)
IF(VORBIS_LIBRARY)
	find_path(VORBIS_FILE vorbisfile.h PATH_SUFFIXES vorbis)
	IF(VORBIS_FILE)
		MESSAGE(STATUS "Looking for Ogg Vorbis support: found")
	ELSE()
		unset(VORBIS_LIBRARY) # disable the build for this plugin
	ENDIF()
ENDIF()
IF(NOT VORBIS_LIBRARY)
	MESSAGE(WARNING "Looking for Ogg Vorbis support: not found!")
	MESSAGE(WARNING "While no original game data is in OGG format, some mod data is and will need conversion.")
ENDIF()

# On Release builds cmake automatically defines NDEBUG, so we
# explicitly undefine it:
# This matches stripped (Release) and nonstripped (RelWithDebInfo) builds
if(CMAKE_BUILD_TYPE MATCHES "Rel.*" AND NOT MSVC)
	ADD_DEFINITIONS("-UNDEBUG")
endif()

if (STATIC_LINK)
	if (NOT WIN32)
		ADD_DEFINITIONS("-DSTATIC_LINK")
	else (NOT WIN32)
		unset(STATIC_LINK CACHE)
		MESSAGE(STATUS "Static linking not (yet) supported on this platform.")
	endif (NOT WIN32)
endif (STATIC_LINK)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} gemrb/includes gemrb/core)

# generate config.h
INCLUDE (config)

IF(APPLE)
	# Make sure we can find the 'ibtool' program. we need it to compile xibs

=== gemrb/CMakeLists.txt ===
ADD_SUBDIRECTORY( core )

# GUIScripts and override go directly in the bundle
SET(RESOURCE_LIST "GUIScripts" "override" "unhardcoded")
IF (USE_OPENGL)
	LIST(APPEND RESOURCE_LIST "plugins/SDLVideo/Shaders")
ENDIF()
SET(RESOURCE_FILES "")

FOREACH(RESOURCE_DIR_NAME ${RESOURCE_LIST})
	SET(RESOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${RESOURCE_DIR_NAME}")
	IF (APPLE)
		FILE(GLOB CHILDREN RELATIVE "${RESOURCE_DIR}" ${RESOURCE_DIR}/*)
		FOREACH(CHILD ${CHILDREN})
			IF(IS_DIRECTORY "${RESOURCE_DIR}/${CHILD}")
				# be wary of .DS_Store files. glob them out by using [A-Za-z]*.*
				FILE(GLOB RESOURCE_DIR_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${RESOURCE_DIR}/${CHILD}/[A-Za-z]*.*")
				SET_SOURCE_FILES_PROPERTIES(
					${RESOURCE_DIR_FILES}
					PROPERTIES MACOSX_PACKAGE_LOCATION Resources/${RESOURCE_DIR_NAME}/${CHILD}
				)
				SET(RESOURCE_FILES ${RESOURCE_FILES} ${RESOURCE_DIR_FILES})
			ELSEIF(NOT ${CHILD} MATCHES "\\.DS_Store|.*\\.am")
				SET_SOURCE_FILES_PROPERTIES(
					"${RESOURCE_DIR}/${CHILD}"
					PROPERTIES MACOSX_PACKAGE_LOCATION Resources/${RESOURCE_DIR_NAME}
				)
				SET(RESOURCE_FILES ${RESOURCE_FILES} "${RESOURCE_DIR_NAME}/${CHILD}")
			ENDIF()
		ENDFOREACH()
	ELSE (APPLE)
		INSTALL( DIRECTORY ${RESOURCE_DIR} DESTINATION "${DATA_DIR}" PATTERN "*.am" EXCLUDE)
	ENDIF (APPLE)
ENDFOREACH()

IF(APPLE) #application bundle generation
	# icon
	SET_SOURCE_FILES_PROPERTIES(
		../artwork/gemrb.icns
		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
	)

	# default values
	SET_SOURCE_FILES_PROPERTIES(
		../apple/defaults.plist
		PROPERTIES MACOSX_PACKAGE_LOCATION Resources
	)

	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../apple/EmptyStringTransformer.m
					../artwork/gemrb.icns ../apple/defaults.plist
					${RESOURCE_FILES})
	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader \"${BUNDLE_LOADER}\"")
ELSE(APPLE)
	ADD_SUBDIRECTORY( docs )
	ADD_SUBDIRECTORY( tests )

	ADD_EXECUTABLE(gemrb GemRB.cpp )

	INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample" GemRB.cfg.noinstall.sample DESTINATION ${EXAMPLE_CONF_DIR} )
ENDIF(APPLE)

# we need to add gemrb target before processing plugins or COCOA plugins don't work right.
ADD_SUBDIRECTORY( plugins )

SET_TARGET_PROPERTIES(gemrb PROPERTIES INSTALL_RPATH ${LIB_DIR})
INCLUDE_DIRECTORIES( ${SDL_INCLUDE_DIR} )
IF(WIN32)
 TARGET_LINK_LIBRARIES(gemrb gemrb_core)
ELSE(WIN32)
 IF(APPLE)
	# custom info.plist
	SET_TARGET_PROPERTIES(gemrb PROPERTIES MACOSX_BUNDLE_INFO_PLIST ../../apple/osx/Info.plist OUTPUT_NAME GemRB)

	# compile nib
	ADD_CUSTOM_COMMAND (TARGET gemrb POST_BUILD 
                      COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text 
                              --compile ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/Resources/GemRB.nib 
                            ${CMAKE_CURRENT_SOURCE_DIR}/../apple/CocoaWrapper/mac/nibs/GemRB.xib
                      COMMENT "Compiling GemRB.xib")

	if (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
			 gemrb_core ${plugins}  -Wl,-all_load)
	else (STATIC_LINK)
		TARGET_LINK_LIBRARIES(gemrb gemrb_core
			  ${COCOA_LIBRARY_PATH} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
	endif (STATIC_LINK)
 ELSE(APPLE)
  if (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
		  -Wl,--whole-archive gemrb_core ${plugins} -Wl,--no-whole-archive)
  else (STATIC_LINK)
	  TARGET_LINK_LIBRARIES(gemrb gemrb_core ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
  endif (STATIC_LINK)
 ENDIF(APPLE)
ENDIF(WIN32)

# preconfigure the sample config with the selected paths
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/GemRB.cfg.sample.in"
  "${CMAKE_CURRENT_BINARY_DIR}/GemRB.cfg.sample"
  IMMEDIATE @ONLY
)

INSTALL( TARGETS gemrb DESTINATION ${BIN_DIR} )

=== debian/changelog ===
gemrb (0.8.4-1) unstable; urgency=medium

  * Import upstream version 0.8.4
  * Revert libsdl2 dependency to libsdl1.2. (Closes: #815215)
  * Increase Standards-Version to 3.9.7.
  * Fix some spelling errors.
  * Refresh patches line numbers.
  * Enable hardening options in debian/rules.
  * Update copyright dates.
  * Update Vcs-Git and Vcs-Browser URIs to https.

 -- Beren Minor <beren.minor+debian@gmail.com>  Mon, 21 Mar 2016 22:29:21 +0100

=== debian/control ===
Source: gemrb
Section: contrib/games
Priority: optional
Maintainer: Beren Minor <beren.minor+debian@gmail.com>
Build-Depends: debhelper (>= 9), cmake, python-dev, libsdl1.2-dev,
 libsdl-mixer1.2-dev, libz-dev, libopenal-dev, libpng-dev,
 libogg-dev, libvorbis-dev, libvlc-dev, libglew-dev, libfreetype6-dev,
 dh-python
Standards-Version: 3.9.7
Homepage: http://www.gemrb.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/gemrb.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-games/gemrb.git

Package: gemrb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python, gemrb-data (=${source:Version}), libgemrb (=${binary:Version})
Recommends: game-data-packager, innoextract, lgogdownloader
Description: Open-source engine to run Baldur's Gate, Icewind Dale and Planescape: Torment
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 It means that you either need some of the original game's data
 somewhere on your harddisk, or you can try to use the data from the
 Dragonlance Total Conversion project.
 .
 The original game data has to be installed on a windows
 partition and mounted to your Linux/Unix filesystem, installed on
 windows and then copied to your filesystem, installed with WINE or
 extracted manually from the CDs using the tool `unshield'.
 .
 Supported games: Baldur's Gate and Icewind Dale series, Planescape:Torment.

Package: libgemrb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared libraries and plugins for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains GemRB core shared libraries and plugins.


Package: gemrb-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains documentation about GemRB and how to write custom games.

Package: gemrb-data
Architecture: all
Depends: ${misc:Depends}
Description: Common data files for GemRB
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files used across all supported games.


Package: gemrb-baldurs-gate-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Baldur's Gate game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Baldur's Gate game.

Package: gemrb-baldurs-gate
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-baldurs-gate-data (=${source:Version})
Description: GemRB binary and configuration for Baldur's Gate game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Baldur's Gate game.


Package: gemrb-baldurs-gate-2-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Baldur's Gate 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Baldur's Gate 2 game.

Package: gemrb-baldurs-gate-2
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-baldurs-gate-2-data (=${source:Version})
Description: GemRB binary and configuration for Baldur's Gate 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Baldur's Gate 2 game.


Package: gemrb-icewind-dale-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Icewind Dale game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Icewind Dale game.

Package: gemrb-icewind-dale
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-icewind-dale-data (=${source:Version})
Description: GemRB binary and configuration for Icewind Dale game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Icewind Dale game.


Package: gemrb-icewind-dale-2-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Icewind Dale 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Icewind Dale 2 game.

Package: gemrb-icewind-dale-2
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-icewind-dale-2-data (=${source:Version})
Description: GemRB binary and configuration for Icewind Dale 2 game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Icewind Dale 2 game.


Package: gemrb-planescape-torment-data
Architecture: all
Depends: ${misc:Depends}, gemrb-data (=${source:Version})
Description: GemRB data files for Planescape: Torment game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains data files for Planescape: Torment game.

Package: gemrb-planescape-torment
Architecture: any
Depends: ${misc:Depends}, gemrb (=${binary:Version}), gemrb-planescape-torment-data (=${source:Version})
Description: GemRB binary and configuration for Planescape: Torment game
 GemRB (Game Engine Made with preRendered Background) is a new implementation
 of the original Infinity Engine (the one of Baldur's Gate, Icewind Dale,
 Planescape: Torment, ...) to Linux/Unix, MacOS X and Windows with some
 enhancements.
 .
 This package contains configuration sample and binary for Planescape: Torment
 game.

## gemrb 0.8.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,21 @@
 ENDIF(DEFINED CMAKE_BUILD_TYPE)
 
 PROJECT(gemrb)
+
+# Options list
+SET(SDL_BACKEND "Auto" CACHE STRING "libSDL version (possible values: Auto, SDL or SDL2)")
+SET_PROPERTY(CACHE SDL_BACKEND PROPERTY STRINGS Auto SDL SDL2)
+
+SET(OPENGL_BACKEND "None" CACHE STRING "OpenGL support (requires SDL2, possible values: None, OpenGL, GLES)")
+SET_PROPERTY(CACHE OPENGL_BACKEND PROPERTY STRINGS None OpenGL GLES)
+
+OPTION(USE_SDLMIXER "Enable SDL_mixer support" ON)
+OPTION(USE_OPENAL "Enable OpenAL support" ON)
+OPTION(USE_LIBVLC "Enable LibVLC support" ON)
+OPTION(USE_FREETYPE "Enable FreeType support" ON)
+OPTION(USE_PNG "Enable LibPNG support" ON)
+OPTION(USE_VORBIS "Enabe Vorbis support" ON)
+
 # try to extract the version from the source
 FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/gemrb/includes/globals.h GLOBALS)
 SET(GEMRB_VERSION "")
@@ -35,7 +50,7 @@
 if(GEMRB_VERSION STREQUAL "") # lookup failed
 	set(GEMRB_VERSION "unknown")
 endif()
-message("Detected version: ${GEMRB_VERSION}")
+message(STATUS "Detected version: ${GEMRB_VERSION}")
 unset(GLOBALS)
 
 IF(PREFIX)
@@ -118,6 +133,9 @@
 	SET_PATH( DOC_DIR "${BIN_DIR}/${PROJECT_NAME}.app/Contents/Resources" )
 	SET_PATH( LIB_DIR @loader_path/../Frameworks )
 endif (${LAYOUT} MATCHES "home")
+# convert the slashes for windows' users' convenience
+file(TO_NATIVE_PATH ${PLUGIN_DIR} DEFAULT_PLUGINS_DIR)
+file(TO_NATIVE_PATH ./Cache2/ DEFAULT_CACHE_DIR)
 
 # check if this is a release version
 SET(RC "")
@@ -127,7 +145,7 @@
 else()
 	set (GIT_VERSION 1)
 endif()
-MESSAGE("Git version bool: ${GIT_VERSION}")
+MESSAGE(STATUS "Git version bool: ${GIT_VERSION}")
 
 IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
 	if ((NOT DISABLE_WERROR) AND GIT_VERSION)
@@ -151,6 +169,11 @@
 	IF (STACK_PROTECTOR)
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-stack-protector")
 	ENDIF ()
+	# use a more lenient regex for finding documented switch fallthroughs (gcc7)
+	CHECK_CXX_COMPILER_FLAG("-Wimplicit-fallthrough" FALLTHROUGH)
+	IF (FALLTHROUGH AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wimplicit-fallthrough=2")
+	ENDIF ()
 	if (WIN32)
 		# GCC 4.5.0+ has shared libstdc++ without dllimport
 		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
@@ -166,6 +189,39 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")
 
+# MODULE is only available since 2.8.8, but that's too new for Travis and IRIX
+MACRO(FIND_PKG_OURS name)
+if (${CMAKE_MAJOR_VERSION} GREATER 2 OR CMAKE_MINOR_VERSION GREATER 8 OR CMAKE_PATCH_VERSION GREATER 8)
+	find_package(${name} MODULE)
+else()
+	find_package(${name})
+endif()
+ENDMACRO(FIND_PKG_OURS)
+
+IF(NOT STATIC_LINK)
+	# prevent static libraries from being selected by FIND_LIBRARY
+	LIST(REMOVE_ITEM CMAKE_FIND_LIBRARY_SUFFIXES ".a")
+ENDIF()
+
+# extra search paths for windows builds through AppVeyor
+IF(WIN32)
+	set(APPVEYOR_DEP_DIR "$ENV{APPVEYOR_DEPS}")
+	set(APPVEYOR_DEP_SEARCH_PATH
+		${APPVEYOR_DEP_DIR}/include/SDL
+		${APPVEYOR_DEP_DIR}/include/AL
+		${APPVEYOR_DEP_DIR}/include/libpng12
+		${APPVEYOR_DEP_DIR}/include/ogg
+		${APPVEYOR_DEP_DIR}/include/vorbis
+		${APPVEYOR_DEP_DIR}/include
+		${APPVEYOR_DEP_DIR}/lib
+		${APPVEYOR_DEP_DIR}
+	)
+	set(CMAKE_PREFIX_PATH ${APPVEYOR_DEP_SEARCH_PATH} ${CMAKE_PREFIX_PATH})
+	message(STATUS "SDLDIR: $ENV{SDLDIR}")
+	message(STATUS "APPVEYOR env: ${APPVEYOR_DEP_DIR}")
+	message(STATUS "APPVEYOR paths: ${APPVEYOR_DEP_SEARCH_PATH}")
+ENDIF()
+
 # Check for all the required and optional dependencies
 FIND_PACKAGE(PythonLibs 2.3 REQUIRED)
 IF(PYTHONLIBS_FOUND)
@@ -175,86 +231,68 @@
 	MESSAGE(FATAL_ERROR "Please get them (www.python.org)")
 ENDIF()
 
-INCLUDE(FindSDL)
-IF(SDL_FOUND)
-	MESSAGE(STATUS "Looking for SDL1: found")
-ELSE()
-	MESSAGE(WARNING "Looking for SDL1: not found!")
-ENDIF()
-
-# look for sdl2 if sdl1 was not found or a preference was stated
-IF(USE_SDL2 OR NOT SDL_FOUND)
+# Autodetection mechanism
+# Default priority to SDL
+# If found both backends and USE_SDL2 is active, switching to SDL2
+IF(SDL_BACKEND STREQUAL "Auto")
+	MESSAGE(STATUS "Autodetecting SDL backend...")
+	INCLUDE(FindSDL)
 	INCLUDE(FindSDL2)
-ENDIF()
-IF(SDL2_FOUND)
-	MESSAGE(STATUS "Looking for SDL2: found")
+	IF(SDL_FOUND)
+		MESSAGE(STATUS "Found SDL 1.2, switching to SDL backend.")
+		SET(SDL_BACKEND "SDL")
+	ENDIF()
+	IF((NOT SDL_FOUND AND SDL2_FOUND) OR (SDL_FOUND AND SDL2_FOUND AND USE_SDL2))
+		MESSAGE(STATUS "Found SDL 2.0, switching to SDL2 backend.")
+		SET(SDL_BACKEND "SDL2")
+	ENDIF()
+	IF(NOT (SDL_FOUND OR SDL2_FOUND))
+		MESSAGE(WARNING "No SDL or SDL2 libraries found.")
+		MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
+	ENDIF()
+ENDIF()
+
+IF((SDL_BACKEND STREQUAL "SDL") AND NOT USE_SDL2)
+	INCLUDE(FindSDL)
+	IF(USE_SDLMIXER)
+		FIND_PKG_OURS(SDL_mixer)
+	ENDIF()
+ENDIF()
+
+IF((SDL_BACKEND STREQUAL "SDL2") OR USE_SDL2)
+	INCLUDE(FindSDL2)
 	# unify SDL variables, so we don't have to differentiate later
 	SET(SDL_INCLUDE_DIR ${SDL2_INCLUDE_DIR})
 	SET(SDL_LIBRARY ${SDL2_LIBRARY})
-	# skip SDL_FOUND for later use
+	SET(SDL_FOUND ${SDL2_FOUND})
+
+	IF(USE_SDLMIXER)
+		FIND_PKG_OURS(SDL2_mixer)
+		# unify variables, so we don't have to differentiate later
+		SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
+		SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
+		SET(SDL_MIXER_VERSION_STRING ${SDL2_MIXER_VERSION_STRING})
+		SET(SDL_MIXER_FOUND ${SDL2_MIXER_FOUND})
+	ENDIF()
+ENDIF()
+
+# backward compatibility notice - remove USE_SDL2 and OPENGL_BACKEND in the future (added mid 2016)
+IF(USE_SDL2)
+	MESSAGE(WARNING "USE_SDL2 has been deprecated, use SDL_BACKEND instead: Auto, SDL, SDL2.")
+ENDIF()
+IF(USE_OPENGL)
+	MESSAGE(WARNING "USE_OPENGL has been deprecated, use OPENGL_BACKEND instead: None, OpenGL, GLES.")
+ENDIF()
+
+IF(SDL_FOUND)
+	MESSAGE(STATUS "Looking for SDL: found")
+	# unify SDL variables, so we don't have to differentiate later
+	MESSAGE(STATUS "Looking for libSDL: found")
 ELSE()
-	MESSAGE(WARNING "Looking for SDL2: not found!")
-	IF(NOT SDL_FOUND)
-		MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
-	ENDIF()
-ENDIF()
-
-IF(USE_OPENGL)
-	IF(NOT SDL2_FOUND)
-		MESSAGE(FATAL_ERROR "SDL2 is required for the OpenGL driver!")
-	ENDIF()
-	INCLUDE(FindOpenGL)
-	IF(NOT OPENGL_FOUND)
-		MESSAGE(FATAL_ERROR "OpenGL library not found!")
-	ENDIF()
-
-	IF(USE_OPENGL EQUAL 1)
-		ADD_DEFINITIONS("-DUSE_GL")
-		INCLUDE(FindGLEW)
-		IF(GLEW_FOUND)
-			MESSAGE(STATUS "Looking for Glew: found")
-		ELSE()
-			MESSAGE(SEND_ERROR "Looking for Glew: not found!")
-			MESSAGE(FATAL_ERROR "Please install the Glew library and headers first!")
-		ENDIF()
-	ELSE()
-		# use GLES instead of regular GL
-		# TODO: check for all the stuff GLES needs
-	ENDIF()
-ENDIF()
-
-INCLUDE(FindZLIB)
-IF(ZLIB_FOUND)
-	MESSAGE(STATUS "Looking for Zlib: found")
-ELSE()
-	MESSAGE(SEND_ERROR "Looking for Zlib: not found!")
-	MESSAGE(FATAL_ERROR "Please install the Zlib library and headers first!")
-ENDIF()
-
-IF(UNIX)
-	SET(CMAKE_THREAD_PREFER_PTHREAD true)
-	FIND_PACKAGE(Threads REQUIRED)
-ENDIF(UNIX)
-
-INCLUDE(FindOpenAL)
-IF(OPENAL_FOUND)
-	MESSAGE(STATUS "Looking for OpenAL: found")
-ELSE()
-	MESSAGE(WARNING "Looking for OpenAL: not found!")
-	MESSAGE(WARNING "If you want to build the OpenAL plugin, get OpenAL from www.openal.org.")
-	MESSAGE(WARNING "If it just wasn't found, try setting the OPENALDIR environment variable.")
-ENDIF()
-
-IF(SDL2_FOUND)
-	FIND_PACKAGE(SDL2_mixer MODULE)
-	# unify variables, so we don't have to differentiate later
-	SET(SDL_MIXER_INCLUDE_DIRS ${SDL2_MIXER_INCLUDE_DIRS})
-	SET(SDL_MIXER_LIBRARIES ${SDL2_MIXER_LIBRARIES})
-	SET(SDL_MIXER_VERSION_STRING ${SDL2_MIXER_VERSION_STRING})
-	SET(SDL_MIXER_FOUND ${SDL2_MIXER_FOUND})
-ELSE()
-	FIND_PACKAGE(SDL_mixer MODULE)
-ENDIF()
+	MESSAGE(WARNING "Looking for SDL: not found!")
+	MESSAGE(FATAL_ERROR "Please get SDL from www.libsdl.org")
+ENDIF()
+
 IF(SDL_MIXER_FOUND)
 	MESSAGE(STATUS "Looking for SDL_mixer: found")
 ELSE()
@@ -263,71 +301,9 @@
 	MESSAGE(WARNING "Make sure you use a version compatible with the chosen SDL version.")
 ENDIF()
 
-FIND_PACKAGE(LIBVLC MODULE)
-IF(LIBVLC_FOUND)
-	MESSAGE(STATUS "Looking for VLC: found")
-ELSE()
-	MESSAGE(WARNING "Looking for VLC: not found!")
-	MESSAGE(WARNING "If you want to build the VLC plugin, install VLC first.")
-ENDIF()
-
-INCLUDE(FindFreetype)
-IF(FREETYPE_FOUND)
-	MESSAGE(STATUS "Looking for Freetype: found")
-	INCLUDE(FindICONV)
-	IF(NOT ICONV_FOUND)
-		MESSAGE(WARNING "Iconv not found. TTF plugin will not be able to translate non-unicode compatible TLK encodings.")
-	ELSE()
-		set(HAVE_ICONV)
-	ENDIF()
-ELSE()
-	MESSAGE(WARNING "Looking for Freetype: not found!")
-	MESSAGE(WARNING "If you want to build the TTF plugin, install Freetype first.")
-ENDIF()
-
-INCLUDE(FindPNG)
-IF(PNG_FOUND)
-	MESSAGE(STATUS "Looking for libPNG: found")
-ELSE()
-	MESSAGE(WARNING "Looking for libPNG: not found!")
-	MESSAGE(WARNING "GemRB will be built without any PNG support. Get it from www.libpng.org" )
-	MESSAGE(WARNING "While no original game data is in PNG format, some mod data is and will need conversion.")
-ENDIF()
-
-FIND_LIBRARY(VORBIS_LIBRARY vorbisfile)
-IF(VORBIS_LIBRARY)
-	find_path(VORBIS_FILE vorbisfile.h PATH_SUFFIXES vorbis)
-	IF(VORBIS_FILE)
-		MESSAGE(STATUS "Looking for Ogg Vorbis support: found")
-	ELSE()
-		unset(VORBIS_LIBRARY) # disable the build for this plugin
-	ENDIF()
-ENDIF()
-IF(NOT VORBIS_LIBRARY)
-	MESSAGE(WARNING "Looking for Ogg Vorbis support: not found!")
-	MESSAGE(WARNING "While no original game data is in OGG format, some mod data is and will need conversion.")
-ENDIF()
-
-# On Release builds cmake automatically defines NDEBUG, so we
-# explicitly undefine it:
-# This matches stripped (Release) and nonstripped (RelWithDebInfo) builds
-if(CMAKE_BUILD_TYPE MATCHES "Rel.*" AND NOT MSVC)
-	ADD_DEFINITIONS("-UNDEBUG")
-endif()
-
-if (STATIC_LINK)
-	if (NOT WIN32)
-		ADD_DEFINITIONS("-DSTATIC_LINK")
-	else (NOT WIN32)
-		unset(STATIC_LINK CACHE)
-		MESSAGE(STATUS "Static linking not (yet) supported on this platform.")
-	endif (NOT WIN32)
-endif (STATIC_LINK)
-
-INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR} gemrb/includes gemrb/core)
-
-# generate config.h
-INCLUDE (config)
-
-IF(APPLE)
-	# Make sure we can find the 'ibtool' program. we need it to compile xibs
+IF((NOT OPENGL_BACKEND STREQUAL "None") OR USE_OPENGL)
+	IF(SDL_BACKEND STREQUAL "SDL")
+		MESSAGE(FATAL_ERROR "SDL2 is required for the OpenGL driver!")
+	ENDIF()
+	INCLUDE(FindOpenGL)
+	IF(NOT OPENGL_FOUND)

=== gemrb/CMakeLists.txt ===
--- 
+++ 
@@ -47,9 +47,32 @@
 	)
 
 	SET(MACOSX_BUNDLE_ICON_FILE gemrb)
-	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE ../apple/CocoaWrapper/mac/CocoaWrapper.mm ../apple/AppleLogger.mm ../apple/EmptyStringTransformer.m
-					../artwork/gemrb.icns ../apple/defaults.plist
+	SET(PRODUCT_NAME "GemRB") # for info.plist
+	
+	ADD_EXECUTABLE(gemrb MACOSX_BUNDLE
+					../apple/CocoaWrapper/mac/CocoaWrapper.mm
+					../apple/AppleLogger.mm
+					../apple/EmptyStringTransformer.m
+					../artwork/gemrb.icns
+					../apple/defaults.plist
 					${RESOURCE_FILES})
+
+	# we already link to Cocoa and we need to modify this with the ‘dylib_file’ option for non-framework SDL builds
+	STRING(REPLACE "-framework Cocoa" "" SDL_LIBRARY ${SDL_LIBRARY})
+	GET_FILENAME_COMPONENT(SDL_LIBRARY ${SDL_LIBRARY} REALPATH)
+	SET(BUNDLE_FRAMEWORK_PATH "${CMAKE_BINARY_DIR}/gemrb/${PROJECT_NAME}.app/Contents/Frameworks")
+					
+	MESSAGE(STATUS "Copying SDL: ${SDL_LIBRARY}")
+	FILE(COPY ${SDL_LIBRARY} DESTINATION ${BUNDLE_FRAMEWORK_PATH} FILE_PERMISSIONS OWNER_READ OWNER_WRITE)
+
+	GET_FILENAME_COMPONENT(SDL_BASENAME ${SDL_LIBRARY} NAME)
+	SET(SDL_LIBRARY "${BUNDLE_FRAMEWORK_PATH}/${SDL_BASENAME}")
+	
+	IF(NOT SDL_BASENAME MATCHES ".framework")
+		# change the "install name" of the copied SDL
+		ADD_CUSTOM_COMMAND(TARGET gemrb PRE_BUILD COMMAND ${CMAKE_INSTALL_NAME_TOOL} -id "@loader_path/../Frameworks/${SDL_BASENAME}" "${SDL_LIBRARY}")
+	ENDIF()
+
 	SET (BUNDLE_LOADER "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app/Contents/MacOS/${PROJECT_NAME}") # BUNDLE_LOADER is used by plugins needing to extend the cocoa wrapper (SDLVideo).
 	SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -bundle_loader \"${BUNDLE_LOADER}\"")
 ELSE(APPLE)

=== gemrb/core/CMakeLists.txt ===
ADD_DEFINITIONS(-DGEM_BUILD_DLL)

IF (ANDROID)
	set (PLATFORM_SRC System/Logger/Android.cpp)
ELSEIF (WIN32)
	set (PLATFORM_SRC System/Logger/Win32Console.cpp)
ELSE ()
	set (PLATFORM_SRC)
ENDIF ()

FILE(GLOB gemrb_core_LIB_SRCS
	ActorMgr.cpp
	Ambient.cpp
	AmbientMgr.cpp
	Animation.cpp
	AnimationFactory.cpp
	AnimationMgr.cpp
	ArchiveImporter.cpp
	Audio.cpp
	Bitmap.cpp
	Cache.cpp
	Calendar.cpp
	CharAnimations.cpp
	Compressor.cpp
	ControlAnimation.cpp
	Core.cpp
	DataFileMgr.cpp
	Dialog.cpp
	DialogHandler.cpp
	DialogMgr.cpp
	DisplayMessage.cpp
	EffectMgr.cpp
	EffectQueue.cpp
	Factory.cpp
	FactoryObject.cpp
	FileCache.cpp
	FontManager.cpp
	Game.cpp
	GameData.cpp
	GlobalTimer.cpp
	Image.cpp
	ImageFactory.cpp
	ImageMgr.cpp
	ImageWriter.cpp
	IndexedArchive.cpp
	IniSpawn.cpp
	Interface.cpp
	InterfaceConfig.cpp
	Inventory.cpp
	Item.cpp
	ItemMgr.cpp
	KeyMap.cpp
	LRUCache.cpp
	Map.cpp
	MapMgr.cpp
	MapReverb.cpp
	MoviePlayer.cpp
	MusicMgr.cpp
	Palette.cpp
	PalettedImageMgr.cpp
	Particles.cpp
	Plugin.cpp
	PluginLoader.cpp
	PluginMgr.cpp
	Polygon.cpp
	Projectile.cpp
	ProjectileMgr.cpp
	ProjectileServer.cpp
	Region.cpp
	Resource.cpp
	ResourceDesc.cpp
	ResourceManager.cpp
	ResourceSource.cpp
	SaveGameIterator.cpp
	SaveGameMgr.cpp
	ScriptEngine.cpp
	ScriptedAnimation.cpp
	SoundMgr.cpp
	Spell.cpp
	SpellMgr.cpp
	Spellbook.cpp
	Sprite2D.cpp
	SpriteCover.cpp
	Store.cpp
	StoreMgr.cpp
	StringMgr.cpp
	SymbolMgr.cpp
	TableMgr.cpp
	Tile.cpp
	TileMap.cpp
	TileMapMgr.cpp
	TileOverlay.cpp
	TileSetMgr.cpp
	Variables.cpp
	VEFObject.cpp
	Video.cpp
	WindowMgr.cpp
	WorldMap.cpp
	WorldMapMgr.cpp
	GameScript/Actions.cpp
	GameScript/GSUtils.cpp
	GameScript/GameScript.cpp
	GameScript/Matching.cpp
	GameScript/Objects.cpp
	GameScript/Triggers.cpp
	GUI/Button.cpp
	GUI/Console.cpp
	GUI/Control.cpp
	GUI/EventMgr.cpp
	GUI/GameControl.cpp
	GUI/Label.cpp
	GUI/MapControl.cpp
	GUI/Progressbar.cpp
	GUI/ScrollBar.cpp
	GUI/Slider.cpp
	GUI/TextArea.cpp
	GUI/TextEdit.cpp
	GUI/TextSystem/Font.cpp
	GUI/TextSystem/GemMarkup.cpp
	GUI/TextSystem/TextContainer.cpp
	GUI/Window.cpp
	GUI/WorldMapControl.cpp
	RNG/RNG_SFMT.cpp
	RNG/sfmt/SFMT.c
	Scriptable/Actor.cpp
	Scriptable/CombatInfo.cpp
	Scriptable/Container.cpp
	Scriptable/Door.cpp
	Scriptable/InfoPoint.cpp
	Scriptable/Scriptable.cpp
	Scriptable/PCStatStruct.cpp
	System/DataStream.cpp
	System/FileStream.cpp
	System/MemoryStream.cpp
	System/Logger.cpp
	System/Logger/File.cpp
	System/Logger/MessageWindowLogger.cpp
	System/Logger/Stdio.cpp
	System/Logging.cpp
	System/SlicedStream.cpp
	System/String.cpp
	System/StringBuffer.cpp
	System/VFS.cpp
	${PLATFORM_SRC}
	)

if (STATIC_LINK)
	ADD_LIBRARY(gemrb_core STATIC ${gemrb_core_LIB_SRCS})
else (STATIC_LINK)
	ADD_LIBRARY(gemrb_core SHARED ${gemrb_core_LIB_SRCS})
	TARGET_LINK_LIBRARIES(gemrb_core ${CMAKE_DL_LIBS} ${COREFOUNDATION_LIBRARY})
	IF(WIN32)
	  INSTALL(TARGETS gemrb_core RUNTIME DESTINATION ${LIB_DIR})
	ELSE(WIN32)
	  INSTALL(TARGETS gemrb_core LIBRARY DESTINATION ${LIB_DIR})
	ENDIF(WIN32)
endif (STATIC_LINK)

# make lintian happy
SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
	VERSION "${GEMRB_VERSION}"
	SOVERSION "${GEMRB_VERSION}"
)

IF (APPLE)
	SET_TARGET_PROPERTIES(gemrb_core PROPERTIES
	INSTALL_NAME_DIR ${LIB_DIR}
	LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/gemrb/${PROJECT_NAME}.app/Contents/Frameworks
)
ENDIF (APPLE)

=== gemrb/plugins/CMakeLists.txt ===
ADD_SUBDIRECTORY( 2DAImporter )
ADD_SUBDIRECTORY( ACMReader )
ADD_SUBDIRECTORY( AREImporter )
ADD_SUBDIRECTORY( BAMImporter )
ADD_SUBDIRECTORY( BIFImporter )
ADD_SUBDIRECTORY( BIKPlayer )
ADD_SUBDIRECTORY( BMPImporter )
ADD_SUBDIRECTORY( BMPWriter )
ADD_SUBDIRECTORY( CHUImporter )
ADD_SUBDIRECTORY( CREImporter )
ADD_SUBDIRECTORY( DLGImporter )
ADD_SUBDIRECTORY( DirectoryImporter )
ADD_SUBDIRECTORY( EFFImporter )
ADD_SUBDIRECTORY( FXOpcodes )
ADD_SUBDIRECTORY( GAMImporter )
ADD_SUBDIRECTORY( GUIScript )
ADD_SUBDIRECTORY( IDSImporter )
ADD_SUBDIRECTORY( INIImporter )
ADD_SUBDIRECTORY( ITMImporter )
ADD_SUBDIRECTORY( IWDOpcodes )
ADD_SUBDIRECTORY( KEYImporter )
ADD_SUBDIRECTORY( MOSImporter )
ADD_SUBDIRECTORY( MUSImporter )
ADD_SUBDIRECTORY( MVEPlayer )
ADD_SUBDIRECTORY( NullSound )
ADD_SUBDIRECTORY( NullSource )
ADD_SUBDIRECTORY( OGGReader )
ADD_SUBDIRECTORY( OpenALAudio )
ADD_SUBDIRECTORY( PLTImporter )
ADD_SUBDIRECTORY( PNGImporter )
ADD_SUBDIRECTORY( PROImporter )
ADD_SUBDIRECTORY( PSTOpcodes )
ADD_SUBDIRECTORY( SAVImporter )
ADD_SUBDIRECTORY( SDLAudio )
ADD_SUBDIRECTORY( SDLVideo )
ADD_SUBDIRECTORY( SPLImporter )
ADD_SUBDIRECTORY( STOImporter )
ADD_SUBDIRECTORY( TISImporter )
ADD_SUBDIRECTORY( TLKImporter )
ADD_SUBDIRECTORY( TTFImporter )
ADD_SUBDIRECTORY( VLCPlayer )
ADD_SUBDIRECTORY( WAVReader )
ADD_SUBDIRECTORY( WEDImporter )
ADD_SUBDIRECTORY( WMPImporter )
ADD_SUBDIRECTORY( ZLibManager )

if (STATIC_LINK)
	SET(plugins ${plugins} PARENT_SCOPE)
endif (STATIC_LINK)

=== gemrb/tests/CMakeLists.txt ===
INSTALL( DIRECTORY minimal DESTINATION ${DATA_DIR} )

=== gemrb/docs/en/CMakeLists.txt ===
INSTALL(
  DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DESTINATION ${DOC_DIR}
  PATTERN CMakeLists.txt EXCLUDE
  PATTERN Makefile.am EXCLUDE
  PATTERN doxygen/* EXCLUDE
)

=== gemrb/plugins/BAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (BAMImporter BAMImporter.cpp BAMFontManager BAMSprite2D.cpp)

=== gemrb/plugins/BIKPlayer/CMakeLists.txt ===
if(HAVE_LDEXPF EQUAL 1)
ADD_GEMRB_PLUGIN ( BIKPlayer BIKPlayer.cpp dct.cpp fft.cpp GetBitContext.cpp mem.cpp rational.cpp rdft.cpp )
endif()

=== gemrb/plugins/IDSImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (IDSImporter IDSImporter.cpp)

=== gemrb/plugins/MOSImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (MOSImporter MOSImporter.cpp)

=== gemrb/plugins/OpenALAudio/CMakeLists.txt ===
#Don't build if openal is not there
IF(OPENAL_FOUND)
INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR} ${SDL_INCLUDE_DIR} )
FILE( GLOB OpenALAudio_files *.cpp )
ADD_GEMRB_PLUGIN (OpenALAudio ${OpenALAudio_files} )
TARGET_LINK_LIBRARIES(OpenALAudio ${OPENAL_LIBRARY} ${SDL_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})
ENDIF(OPENAL_FOUND)

=== gemrb/plugins/PROImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (PROImporter PROImporter.cpp)

=== debian/changelog ===
gemrb (0.8.5-1) unstable; urgency=medium

  * Import upstream version 0.8.5
  * Increase Standards-Version to 4.1.1.
  * Refresh patches line numbers.
  * Update copyright dates.

 -- Beren Minor <beren.minor+debian@gmail.com>  Mon, 27 Nov 2017 19:45:37 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libsdl-mixer1.2-dev, libz-dev, libopenal-dev, libpng-dev,
  libogg-dev, libvorbis-dev, libvlc-dev, libglew-dev, libfreetype6-dev,
  dh-python
-Standards-Version: 3.9.7
+Standards-Version: 4.1.1
 Homepage: http://www.gemrb.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/gemrb.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-games/gemrb.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python2

override_dh_makeshlibs:
	dh_makeshlibs -n

## gemrb 0.9.0%2Bdfsg

=== gemrb/plugins/GAMImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (GAMImporter GAMImporter.cpp)

=== gemrb/plugins/WMPImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (WMPImporter WMPImporter.cpp)
